/*
 * CG Madness - a Marble Madness clone
 * Copyright (C) 2007  Sven Reinck <sreinck@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef NetworkBall_hpp
#define NetworkBall_hpp

#include "Ball.hpp"

#include "utils/String.hpp"

#include "Color.hpp"

class NetworkBall : public Ball
{
public:
  static void init();

public:
  NetworkBall();
  virtual ~NetworkBall();

  void alive();

  String& name();
  Color3& color();

  void update(float interval);

private:
	static int sTextureBallDead;

private:
	int mDeadCounter;

	String mName;
	Color3 mColor;

  void drawBall() const;
  void drawExplosion() const;

  void activateBallShader() const;
  void deactivateBallShader() const;

};

inline String& NetworkBall::name()
{
	return mName;
}

inline Color3& NetworkBall::color()
{
	return mColor;
}

#endif
